net.sf.saxon.expr.instruct

## Class ComputedAttribute

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.SimpleNodeConstructor
      - - net.sf.saxon.expr.instruct.AttributeCreator
        - - net.sf.saxon.expr.instruct.ComputedAttribute

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, TailCallReturner, ValidatingInstruction, InstructionInfo, Locator

      public final class ComputedAttribute
      extends AttributeCreator

  An instruction derived from an xsl:attribute element in stylesheet, or from an attribute constructor in XQuery, in cases where the attribute name is not known statically
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.instruct.SimpleNodeConstructor

      `select`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ComputedAttribute(Expression attributeName, Expression namespace, NamespaceResolver nsContext, int validationAction, SimpleType schemaType, boolean allowNameAsQName)` Construct an Attribute instruction

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
    `int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
    `Expression` | `copy()` Copy an expression.
    `Item` | `evaluateItem(XPathContext context)` Evaluate as an expression.
    `NodeName` | `evaluateNodeName(XPathContext context)` Determine the name to be used for the attribute, as an integer name code
    `void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
    `int` | `getCardinality()` Get the static cardinality of this expression
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler of the ComputedAttribute expression
    `int` | `getInstructionNameCode()` Get the name of this instruction
    `ItemType` | `getItemType(TypeHierarchy th)` Get the static type of this expression
    `Expression` | `getNameExpression()` Get the expression used to compute the name of the attribute
    `Expression` | `getNamespaceExpression()` Get the expression used to compute the namespace part of the name of the attribute
    `NamespaceResolver` | `getNamespaceResolver()` Get the namespace resolver used to resolve any prefix in the name of the attribute
    `Expression` | `getOnEmpty()` Get the on-empty expression, which defines the value to be returned if the attribute would otherwise be empty
    `boolean` | `isAllowNameAsQName()` Ask whether it is allowed for the name to be evaluted as an xs:QName instance (true in XQuery)
    `Iterator<SubExpressionInfo>` | `iterateSubExpressionInfo()` Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Iterator<Expression>` | `iterateSubExpressions()` Get the subexpressions of this expression
    `void` | `localTypeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Method to perform type-checking specific to the kind of instruction
    `Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
    `void` | `processValue(CharSequence value, XPathContext context)` Process the value of the node, to create the new node.
    `protected void` | `promoteInst(PromotionOffer offer)` Offer promotion for subexpressions.
    `boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
    `void` | `setOnEmpty(Expression onEmpty)` Set the on-empty expression, which defines the value to be returned if the attribute would otherwise be empty
    `void` | `setRejectDuplicates()` Indicate that two attributes with the same name are not acceptable.
    `Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.AttributeCreator

      `getOptions, getSchemaType, getValidationAction, setNoSpecialChars, setOptions, setSchemaType, setValidationAction, validateOrphanAttribute`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.SimpleNodeConstructor

      `checkContent, computeCardinality, createsNewNodes, getContentExpression, getStreamingAdjunct, iterate, processLeavingTail, setSelect, typeCheck`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getConstructType, getExpressionName, getImplementationMethod, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, process, promote`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamability, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, toString, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javax.xml.transform.SourceLocator

      `getColumnNumber, getLineNumber, getPublicId, getSystemId`

- - ### Constructor Detail

    - #### ComputedAttribute

          public ComputedAttribute(Expression attributeName,
                           Expression namespace,
                           NamespaceResolver nsContext,
                           int validationAction,
                           SimpleType schemaType,
                           boolean allowNameAsQName)

      Construct an Attribute instruction
      Parameters:
        `attributeName` - An expression to calculate the attribute name
        `namespace` - An expression to calculate the attribute namespace
        `nsContext` - a NamespaceContext object containing the static namespace context of the stylesheet instruction
        `validationAction` - e.g. validation=strict, lax, strip, preserve
        `schemaType` - Type against which the attribute must be validated. This must not be a namespace-sensitive type; it is the caller's responsibility to check this.
        `allowNameAsQName` - true if the attributeName expression is allowed to evaluate to a value of type xs:QName (true in XQuery, false in XSLT)

  - ### Method Detail

    - #### setOnEmpty

          public void setOnEmpty(Expression onEmpty)

      Set the on-empty expression, which defines the value to be returned if the attribute would otherwise be empty
      Parameters:
        `onEmpty` - the expression to be evaluated if the attribute would otherwise be empty

    - #### getOnEmpty

          public Expression getOnEmpty()

      Get the on-empty expression, which defines the value to be returned if the attribute would otherwise be empty
      Returns:
        the on-empty expression if there is one, or null otherwise

    - #### setRejectDuplicates

          public void setRejectDuplicates()

      Indicate that two attributes with the same name are not acceptable. (This option is set in XQuery, but not in XSLT)
      Overrides:
        `setRejectDuplicates` in class `AttributeCreator`

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the name of this instruction
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

    - #### getNameExpression

          public Expression getNameExpression()

      Get the expression used to compute the name of the attribute
      Returns:
        the expression used to compute the name of the attribute

    - #### getNamespaceExpression

          public Expression getNamespaceExpression()

      Get the expression used to compute the namespace part of the name of the attribute
      Returns:
        the expression used to compute the namespace part of the name of the attribute

    - #### getNamespaceResolver

          public NamespaceResolver getNamespaceResolver()

      Get the namespace resolver used to resolve any prefix in the name of the attribute
      Returns:
        the namespace resolver if one has been saved; or null otherwise

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Get the static type of this expression
      Overrides:
        `getItemType` in class `AttributeCreator`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the static type of the item returned by this expression

    - #### getCardinality

          public int getCardinality()

      Get the static cardinality of this expression
      Overrides:
        `getCardinality` in class `Expression`
      Returns:
        the static cardinality (exactly one)

    - #### isAllowNameAsQName

          public boolean isAllowNameAsQName()

      Ask whether it is allowed for the name to be evaluted as an xs:QName instance (true in XQuery)
      Returns:
        the boolean if name is allowed as a QName

    - #### computeSpecialProperties

          public int computeSpecialProperties()

      Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.
      Overrides:
        `computeSpecialProperties` in class `AttributeCreator`
      Returns:
        a set of flags indicating static properties of this expression

    - #### simplify

          public Expression simplify(ExpressionVisitor visitor)
                              throws XPathException

      Description copied from class: `Instruction`
      Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.
      Overrides:
        `simplify` in class `SimpleNodeConstructor`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the simplified expression
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### localTypeCheck

          public void localTypeCheck(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Description copied from class: `SimpleNodeConstructor`
      Method to perform type-checking specific to the kind of instruction
      Specified by:
        `localTypeCheck` in class `SimpleNodeConstructor`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of the context item
      Throws:
        `XPathException` - if a type error is detected

    - #### optimize

          public Expression optimize(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `SimpleNodeConstructor`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Returns:
        the copy of the original expression

    - #### iterateSubExpressions

          public Iterator<Expression> iterateSubExpressions()

      Get the subexpressions of this expression
      Overrides:
        `iterateSubExpressions` in class `SimpleNodeConstructor`
      Returns:
        an iterator over the subexpressions

    - #### iterateSubExpressionInfo

          public Iterator<SubExpressionInfo> iterateSubExpressionInfo()

      Description copied from class: `SimpleNodeConstructor`
      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.
      Overrides:
        `iterateSubExpressionInfo` in class `SimpleNodeConstructor`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### replaceSubExpression

          public boolean replaceSubExpression(Expression original,
                                     Expression replacement)

      Replace one subexpression by a replacement subexpression
      Overrides:
        `replaceSubExpression` in class `SimpleNodeConstructor`
      Parameters:
        `original` - the original subexpression
        `replacement` - the replacement subexpression
      Returns:
        true if the original subexpression is found

    - #### promoteInst

          protected void promoteInst(PromotionOffer offer)
                              throws XPathException

      Offer promotion for subexpressions. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.
      Overrides:
        `promoteInst` in class `SimpleNodeConstructor`
      Parameters:
        `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
      Throws:
        `XPathException` - if any error is detected

    - #### checkPermittedContents

          public void checkPermittedContents(SchemaType parentType,
                                    StaticContext env,
                                    boolean whole)
                                      throws XPathException

      Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.
      Overrides:
        `checkPermittedContents` in class `Expression`
      Parameters:
        `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
        `env` - the static context
        `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
      Throws:
        `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

    - #### evaluateNodeName

          public NodeName evaluateNodeName(XPathContext context)
                                    throws XPathException

      Determine the name to be used for the attribute, as an integer name code
      Overrides:
        `evaluateNodeName` in class `SimpleNodeConstructor`
      Parameters:
        `context` - Dynamic evaluation context
      Returns:
        the integer name code for the attribute name
      Throws:
        `XPathException`

    - #### processValue

          public void processValue(CharSequence value,
                          XPathContext context)
                            throws XPathException

      Process the value of the node, to create the new node.
      Overrides:
        `processValue` in class `AttributeCreator`
      Parameters:
        `value` - the string value of the new node
        `context` - the dynamic evaluation context
      Throws:
        `XPathException`

    - #### evaluateItem

          public Item evaluateItem(XPathContext context)
                            throws XPathException

      Description copied from class: `SimpleNodeConstructor`
      Evaluate as an expression.
      Overrides:
        `evaluateItem` in class `SimpleNodeConstructor`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the compiler of the ComputedAttribute expression
      Overrides:
        `getExpressionCompiler` in class `Expression`
      Returns:
        the relevant ExpressionCompiler

    - #### explain

          public void explain(ExpressionPresenter out)

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `explain` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.